;;; DO NOT MODIFY THIS FILE
(if (featurep 'xemacs-base-custom-defines) (error "Feature xemacs-base-custom-defines already loaded"))

;;;### (autoloads (add-log-current-defun-header-regexp change-log-version-number-regexp-list change-log-version-info-enabled add-log-file-name-function add-log-buffer-file-name-function add-log-always-start-new-record add-log-keep-changes-together add-log-time-format add-log-mailing-address add-log-full-name add-log-current-defun-function change-log-mode-hook change-log-default-name change-log) "add-log" "xemacs-base/add-log.el")
(defconst custom-define-current-source-file "add-log.el")

(defgroup change-log nil "Change log maintenance" :group 'tools :group 'maint :link '(custom-manual "(emacs)Change Log") :prefix "change-log-" :prefix "add-log-")

(defcustom change-log-default-name nil "\
*Name of a change log file for \\[add-change-log-entry]." :type '(choice (const :tag "default" nil) string) :group 'change-log)

(defcustom change-log-mode-hook nil "\
Normal hook run by `change-log-mode'." :type 'hook :group 'change-log)

(defcustom add-log-current-defun-function nil "\
*If non-nil, function to guess name of surrounding function.
It is used by `add-log-current-defun' in preference to built-in rules.
Returns function's name as a string, or nil if outside a function." :type '(choice (const nil) function) :group 'change-log)

(defcustom add-log-full-name nil "\
*Full name of user, for inclusion in ChangeLog daily headers.
This defaults to the value returned by the function `user-full-name'." :type '(choice (const :tag "Default" nil) string) :group 'change-log)

(defcustom add-log-mailing-address nil "\
*Electronic mail addresses of user, for inclusion in ChangeLog headers.
This defaults to the value of `user-mail-address'.  In addition to
being a simple string, this value can also be a list.  All elements
will be recognized as referring to the same user; when creating a new
ChangeLog entry, one element will be chosen at random." :type '(choice (const :tag "Default" nil) (string :tag "String") (repeat :tag "List of Strings" string)) :group 'change-log)

(defcustom add-log-time-format 'iso8601-time-string "\
*Function that defines the time format.
For example, `iso8601-time-string' (time in international ISO 8601 format)
and `current-time-string' are valid values." :type '(radio (const :tag "International ISO 8601 format" iso8601-time-string) (const :tag "Old format, as returned by `current-time-string'" current-time-string) (function :tag "Other")) :group 'change-log)

(defcustom add-log-keep-changes-together nil "\
*If non-nil, normally keep day's log entries for one file together.

Log entries for a given file made with \\[add-change-log-entry] or
\\[add-change-log-entry-other-window] will only be added to others for that file made
today if this variable is non-nil or that file comes first in today's
entries.  Otherwise another entry for that file will be started.  An
original log:

	* foo (...): ...
	* bar (...): change 1

in the latter case, \\[add-change-log-entry-other-window] in a buffer visiting `bar', yields:

	* bar (...): -!-
	* foo (...): ...
	* bar (...): change 1

and in the former:

	* foo (...): ...
	* bar (...): change 1
	(...): -!-

The NEW-ENTRY arg to `add-change-log-entry' can override the effect of
this variable." :version "20.3" :type 'boolean :group 'change-log)

(defcustom add-log-always-start-new-record nil "\
*If non-nil, `add-change-log-entry' will always start a new record." :version "21.4" :type 'boolean :group 'change-log)

(defcustom add-log-buffer-file-name-function nil "\
*If non-nil, function to call to identify the full filename of a buffer.
This function is called with no argument.  If this is nil, the default is to
use `buffer-file-name'." :type '(choice (const nil) function) :group 'change-log)

(defcustom add-log-file-name-function nil "\
*If non-nil, function to call to identify the filename for a ChangeLog entry.
This function is called with one argument, the value of variable
`buffer-file-name' in that buffer.  If this is nil, the default is to
use the file's name relative to the directory of the change log file." :type '(choice (const nil) function) :group 'change-log)

(defcustom change-log-version-info-enabled nil "\
*If non-nil, enable recording version numbers with the changes." :version "21.1" :type 'boolean :group 'change-log)

(defcustom change-log-version-number-regexp-list (let ((re "\\([0-9]+.[0-9.]+\\)")) (list (concat "^(def[^ 	\n]+[ 	]+[^ 	\n][ 	]\"" re) (concat "^;+ *Revision: +[^ 	\n]+[ 	]+" re))) "\
*List of regexps to search for version number.
The version number must be in group 1.
Note: The search is conducted only within 10%, at the beginning of the file." :version "21.1" :type '(repeat regexp) :group 'change-log)

(defcustom add-log-current-defun-header-regexp "^\\([[:upper:]][[:upper:]_0-9 ]*[[:upper:]_0-9]\\|[-_.[:alpha:]0-9]+\\)[ 	]*[:=]" "\
*Heuristic regexp used by `add-log-current-defun' for unknown major modes." :type 'regexp :group 'change-log)

;;;***

;;;### (autoloads (comint) "comint-xemacs" "xemacs-base/comint-xemacs.el")
(defconst custom-define-current-source-file "comint-xemacs.el")

(defgroup comint nil "General command interpreter in a window stuff." :group 'processes)

;;;***

;;;### (autoloads (comint-goto-source-line-hook comint-find-source-file-hook comint-find-source-code-max-lines comint-completion-fignore comint-completion-recexact comint-completion-addsuffix comint-completion-autolist comint-history-menu-max comint-mode-hook comint-eol-on-send comint-append-old-input comint-password-prompt-regexp comint-process-echoes comint-buffer-maximum-size comint-scroll-show-maximum-output comint-scroll-to-bottom-on-output comint-scroll-to-bottom-on-input comint-input-ring-file-name comint-input-ignoredups comint-input-autoexpand) "comint" "xemacs-base/comint.el")
(defconst custom-define-current-source-file "comint.el")

(defcustom comint-input-autoexpand nil "\
*If non-nil, expand input command history references on completion.
This mirrors the optional behavior of tcsh (its autoexpand and histlit).

If the value is `input', then the expansion is seen on input.
If the value is `history', then the expansion is only when inserting
into the buffer's input ring.  See also `comint-magic-space' and
`comint-dynamic-complete'.

This variable is buffer-local." :type '(choice (const :tag "off" nil) (const :tag "on" t) (const input) (const history)) :group 'comint)

(defcustom comint-input-ignoredups t "\
*If non-nil, don't add input matching the last on the input ring.
This mirrors the optional behavior of bash.

This variable is buffer-local." :type 'boolean :group 'comint)

(defcustom comint-input-ring-file-name nil "\
*If non-nil, name of the file to read/write input history.
See also `comint-read-input-ring' and `comint-write-input-ring'.

This variable is buffer-local, and is a good thing to set in mode hooks." :type '(choice (const :tag "None" nil) (file)) :group 'comint)

(defcustom comint-scroll-to-bottom-on-input nil "\
*Controls whether input to interpreter causes window to scroll.
If nil, then do not scroll.  If t or `all', scroll all windows showing buffer.
If `this', scroll only the selected window.

The default is nil.

See `comint-preinput-scroll-to-bottom'.  This variable is buffer-local." :type '(choice (const :tag "off" nil) (const t) (const all) (const this)) :group 'comint)

(defcustom comint-scroll-to-bottom-on-output nil "\
*Controls whether interpreter output causes window to scroll.
If nil, then do not scroll.  If t or `all', scroll all windows showing buffer.
If `this', scroll only the selected window.
If `others', scroll only those that are not the selected window.

The default is nil.

See variable `comint-scroll-show-maximum-output' and function
`comint-postoutput-scroll-to-bottom'.  This variable is buffer-local." :type '(choice (const :tag "off" nil) (const t) (const all) (const this) (const others)) :group 'comint)

(defcustom comint-scroll-show-maximum-output t "\
*Controls how interpreter output causes window to scroll.
If non-nil, then show the maximum output when the window is scrolled.

You may set this to an integer number of lines to keep shown, or a
floating point percentage of the window size to keep filled.
A negative number expresses a distance from the bottom, as when using
a prefix argument with `recenter' (bound to `\\[recenter]').

See variable `comint-scroll-to-bottom-on-output' and function
`comint-postoutput-scroll-to-bottom'.  This variable is buffer-local." :type '(choice (const :tag "Off" nil) (const :tag "On" t) (integer :tag "Number of lines" 20) (number :tag "Decimal Percent of window" 0.85)) :group 'comint)

(defcustom comint-buffer-maximum-size 1024 "\
*The maximum size in lines for comint buffers.
Comint buffers are truncated from the top to be no greater than this number, if
the function `comint-truncate-buffer' is on `comint-output-filter-functions'." :type 'integer :group 'comint)

(defcustom comint-process-echoes nil "\
*If non-nil, assume that the subprocess echoes any input.
If so, delete one copy of the input so that only one copy eventually
appears in the buffer.

This variable is buffer-local." :type 'boolean :group 'comint)

(defcustom comint-password-prompt-regexp (if (eq system-type 'aix-v3) "\\(\\([Oo]ld \\|[Nn]ew \\|^\\|^..*s \\)[Pp]assword\\|pass ?phrase\\):\\s *\\'" "\\(\\([Oo]ld \\|[Nn]ew \\|^\\)[Pp]assword\\|pass ?phrase\\):\\s *\\'") "\
*Regexp matching prompts for passwords in the inferior process.
This is used by `comint-watch-for-password-prompt'." :type 'regexp :group 'comint)

(defcustom comint-append-old-input t "\
*If nil, old text selected by \\[comint-send-input] is re-sent immediately.
If non-nil, the old text is appended to the end of the buffer,
and a prompting message is printed.

This flag does not affect the behavior of \\[comint-send-input]
after the process output mark." :type 'boolean :group 'comint)

(defcustom comint-eol-on-send t "\
*Non-nil means go to the end of the line before sending input.
See `comint-send-input'." :type 'boolean :group 'comint)

(defcustom comint-mode-hook 'nil "\
Called upon entry into comint-mode
This is run before the process is cranked up." :type 'hook :group 'comint)

(defcustom comint-history-menu-max 40 "\
*Maximum number of entries to display on the Comint command-history menu." :type 'integer :group 'comint)

(defcustom comint-completion-autolist nil "\
*If non-nil, automatically list possibilities on partial completion.
This mirrors the optional behavior of tcsh." :type 'boolean :group 'comint-completion)

(defcustom comint-completion-addsuffix t "\
*If non-nil, add a `/' to completed directories, ` ' to file names.
If a cons pair, it should be of the form (DIRSUFFIX . FILESUFFIX) where
DIRSUFFIX and FILESUFFIX are strings added on unambiguous or exact completion.
This mirrors the optional behavior of tcsh." :type 'boolean :group 'comint-completion)

(defcustom comint-completion-recexact nil "\
*If non-nil, use shortest completion if characters cannot be added.
This mirrors the optional behavior of tcsh.

A non-nil value is useful if `comint-completion-autolist' is non-nil too." :type 'boolean :group 'comint-completion)

(defcustom comint-completion-fignore nil "\
*List of suffixes to be disregarded during file completion.
This mirrors the optional behavior of bash and tcsh.

Note that this applies to `comint-dynamic-complete-filename' only." :type '(repeat (string :tag "Suffix")) :group 'comint-completion)

(defcustom comint-find-source-code-max-lines 100 "\
*Maximum number of lines to search backward for a source location,
when using \\[comint-find-source-code\\] with an interactive prefix." :type 'integer :group 'comint-source)

(defcustom comint-find-source-file-hook nil "\
*Function to call instead of comint-default-find-source-file
when comint-find-source-code parses out a file name and then wants to
visit its buffer.  The sole argument is the file name.  The function
must find the file, setting the current buffer, and return the file
name.  It may also adjust the file name.  If you change this variable,
make it buffer local." :type 'function :group 'comint-source)

(defcustom comint-goto-source-line-hook nil "\
*Function to call instead of comint-default-goto-source-line
after comint-find-source-code finds a file and then wants to
go to a line number mentioned in a source location.
The sole argument is the line number.  The function must
return the line number, possibly adjusted.  If you change
this variable, make it buffer local." :type 'function :group 'comint-source)

;;;***

;;;### (autoloads (compilation-mouse-motion-initiate-parsing compile-command compilation-search-path grep-all-files-omitted-directories grep-all-files-omitted-expressions grep-command compilation-ask-about-kill compilation-ask-about-save compilation-read-command compilation-error-screen-columns compilation-error-regexp-systems-list compilation-always-signal-completion compilation-finish-function compilation-shell-minor-mode-menubar-menu-name compilation-buffer-name-function compilation-window-height compilation-mode-hook compilation) "compile" "xemacs-base/compile.el")
(defconst custom-define-current-source-file "compile.el")

(defgroup compilation nil "Run compiler as inferior of Emacs, parse error messages." :group 'programming :group 'tools :group 'processes)

(defcustom compilation-mode-hook nil "\
*List of hook functions run by `compilation-mode' (see `run-hooks')." :type 'hook :group 'compilation)

(defcustom compilation-window-height nil "\
*Number of lines in a compilation window.  If nil, use Emacs default." :type '(choice (const nil) integer) :group 'compilation)

(defcustom compilation-buffer-name-function nil "\
Function to compute the name of a compilation buffer.
The function receives one argument, the name of the major mode of the
compilation buffer.  It should return a string.
nil means compute the name with `(concat \"*\" (downcase major-mode) \"*\")'." :type 'function :group 'compilation)

(defcustom compilation-shell-minor-mode-menubar-menu-name "Errors" "\
*Name of the menubar menu which displays error-navigation items." :type 'string :group 'compilation)

(defcustom compilation-finish-function nil "\
*Function to call when a compilation process finishes.
It is called with two arguments: the compilation buffer, and a string
describing how the process finished." :type 'function :group 'compilation)

(defcustom compilation-always-signal-completion nil "\
*Always give an audible signal upon compilation completion.
By default that signal is only given if the bottom of the compilation
buffer is not visible in its window." :type 'boolean :group 'compilation)

(defcustom compilation-error-regexp-systems-list 'all "\
*This is either the symbol `all', or a list of systems for which
compilation error regexps should be included in
`compilation-error-regexp-alist'.  You must run the function
`compilation-build-compilation-error-regexp-alist' after changing
the value of this variable for the change to take effect.

The list of known systems is:
  4bsd:       Using 4bsd
  ada:        Ada compilers
  aix:        the operating system
  ant:        Ant Java
  borland:    Using Borland
  caml:       Using caml compiler
  comma:      Using tool that says \"foo.c\", line 12
  cray:       Using Cray
  epc:        Using EPC F90 compiler
  gnu:        but of course
  iar:        Using IAR systems compiler
  ibm:        IBM C compilers
  lcc:        Lucid compilers
  mips:       Using Mips
  msft:       Using microsoft
  of:         Using tool that says line xx of foo.c
  oracle:     Using Oracle pro*c
  perl:       perl -w
  python:     Using python
  rxp:        Using RPX GPL XML validator
  sgi:        Using SGI
  sgimipspro: Using SGI Mipspro 7.3
  sun:        Using Sun F90 compiler
  ultrix:     Using DEC unixoid operating system

See also the variable `compilation-error-regexp-alist-alist'." :type '(choice (const all) (set :menu-tag "Pick" (const 4bsd) (const ada) (const aix) (const ant) (const borland) (const caml) (const comma) (const cray) (const epc) (const gnu) (const iar) (const ibm) (const lcc) (const mips) (const msft) (const of) (const oracle) (const perl) (const python) (const rxp) (const sgi) (const sgimipspro) (const sun) (const ultrix))) :set (lambda (symbol value) (set-default symbol value) (compilation-build-compilation-error-regexp-alist)) :group 'compilation)

(defcustom compilation-error-screen-columns t "\
*If non-nil, column numbers in error messages are screen columns.
Otherwise they are interpreted as character positions, with
each character occupying one column.
The default is to use screen columns, which requires that the compilation
program and Emacs agree about the display width of the characters,
especially the TAB character." :type 'boolean :group 'compilation :version "20.4")

(defcustom compilation-read-command t "\
*Non-nil means \\[compile] reads the compilation command to use.
Otherwise, \\[compile] just uses the value of `compile-command'." :type 'boolean :group 'compilation)

(defcustom compilation-ask-about-save t "\
*Non-nil means \\[compile] asks which buffers to save before compiling.
Otherwise, it saves all modified buffers without asking." :type 'boolean :group 'compilation)

(defcustom compilation-ask-about-kill t "\
*If not nil, M-x compile asks to kill a running compilation.
Otherwise, it kills it without asking." :type 'boolean :group 'compilation)

(defcustom grep-command "grep -n " "\
*Last grep command used in \\[grep]; default for next grep." :type 'string :group 'compilation)

(defcustom grep-all-files-omitted-expressions '("*~" "#*" ".#*" ",*" "*.elc" "*.obj" "*.o" "*.exe" "*.dll" "*.lib" "*.a" "*.dvi" "*.class" "*.bin" "*.orig" "*.rej") "\
List of expressions matching files to be omitted in `grep-all-files-...'.
Each entry should be a simple name or a shell wildcard expression." :type '(repeat string) :group 'compilation)

(defcustom grep-all-files-omitted-directories '("CVS" "RCS" "SCCS") "\
List of directories not to recurse into in `grep-all-files-...'.
Each entry should be a simple name or a shell wildcard expression." :type '(repeat string) :group 'compilation)

(defcustom compilation-search-path '(nil) "\
*List of directories to search for source files named in error messages.
Elements should be directory names, not file names of directories.
nil as an element means to try the default directory." :type '(repeat (choice (const :tag "Default" nil) directory)) :group 'compilation)

(defcustom compile-command "make -k " "\
*Last shell command used to do a compilation; default for next compilation.

Sometimes it is useful for files to supply local values for this variable.
You might also use mode hooks to specify it in certain modes, like this:

    (add-hook 'c-mode-common-hook
	      (lambda ()
		(or (file-exists-p \"makefile\") (file-exists-p \"Makefile\")
		    (set (make-local-variable 'compile-command)
			 (concat \"make -k \" buffer-file-name)))))" :type 'string :group 'compilation)

(defcustom compilation-mouse-motion-initiate-parsing nil "\
*Should mouse motion over the compilation buffer initiate parsing?
When set to a non-nil value, mouse motion over the compilation/grep
buffer may initiate parsing of the error messages or grep hits.
When this is nil, errors and grep matches will no longer be 
highlighted until they have been parsed, but may still be selected
with the center mouse button.  This will then initiate parsing
and jump to the corresponding source line." :type 'boolean :group 'compilation)

;;;***

;;;### (autoloads (debugger-record-buffer debugger-step-after-exit debug-function-list debugger-batch-max-lines debugger-mode-hook debugger) "debug" "xemacs-base/debug.el")
(defconst custom-define-current-source-file "debug.el")

(defgroup debugger nil "Debuggers and related commands for Emacs." :prefix "debugger-" :group 'debug)

(defcustom debugger-mode-hook nil "\
*Hooks run when `debugger-mode' is turned on." :type 'hook :group 'debugger :version "20.3")

(defcustom debugger-batch-max-lines 40 "\
*Maximum lines to show in debugger buffer in a noninteractive Emacs.
When the debugger is entered and Emacs is running in batch mode,
if the backtrace text has more than this many lines,
the middle is discarded, and just the beginning and end are displayed." :type 'integer :group 'debugger :version "21.1")

(defcustom debug-function-list nil "\
List of functions currently set for debug on entry." :type '(repeat function) :group 'debugger)

(defcustom debugger-step-after-exit nil "\
Non-nil means \"single-step\" after the debugger exits." :type 'boolean :group 'debugger)

(defcustom debugger-record-buffer "*Debugger-record*" "\
*Buffer name for expression values, for \\[debugger-record-expression]." :type 'string :group 'debugger :version "20.3")

;;;***

;;;### (autoloads (edmacro-format-hook edmacro-eight-bits edmacro) "edmacro" "xemacs-base/edmacro.el")
(defconst custom-define-current-source-file "edmacro.el")

(defgroup edmacro nil "Keyboard macro editor." :group 'keyboard)

(defcustom edmacro-eight-bits nil "\
*Non-nil if edit-kbd-macro should leave 8-bit characters intact.
Default nil means to write characters above \\177 in octal notation." :type 'boolean :group 'edmacro)

(defcustom edmacro-format-hook nil "\
*Hook run after formatting the keyboard macro." :type 'hook :group 'edmacro)

;;;***

;;;### (autoloads (enriched-mode-hook enriched-verbose enriched) "enriched" "xemacs-base/enriched.el")
(defconst custom-define-current-source-file "enriched.el")

(defgroup enriched nil "Read and save files in text/enriched format" :group 'wp)

(defcustom enriched-verbose t "\
*If non-nil, give status messages when reading and writing files." :type 'boolean :group 'enriched)

(defcustom enriched-mode-hook nil "\
Functions to run when entering Enriched mode.
If you set variables in this hook, you should arrange for them to be restored
to their old values if you leave Enriched mode.  One way to do this is to add
them and their old values to `enriched-old-bindings'." :type 'hook :group 'enriched)

;;;***

;;;### (autoloads (facemenu-remove-face-function facemenu-end-add-face facemenu-add-face-function facemenu-relevant-face-attributes facemenu-unlisted-faces facemenu-new-faces-at-end facemenu-keybindings facemenu) "facemenu" "xemacs-base/facemenu.el")
(defconst custom-define-current-source-file "facemenu.el")

(defgroup facemenu nil "Create a face menu for interactively adding fonts to text." :group 'faces :prefix "facemenu-")

(defcustom facemenu-keybindings '((default . "d") (bold . "b") (italic . "i") (bold-italic . "l") (underline . "u")) "\
Alist of interesting faces and keybindings. 
Each element is itself a list: the car is the name of the face,
the next element is the key to use as a keyboard equivalent of the menu item;
the binding is made in `facemenu-keymap'.

The faces specifically mentioned in this list are put at the top of
the menu, in the order specified.  All other faces which are defined,
except for those in `facemenu-unlisted-faces', are listed after them, 
but get no keyboard equivalents.

If you change this variable after loading facemenu.el, you will need to call
`facemenu-update' to make it take effect." :type '(repeat (cons face string)) :group 'facemenu)

(defcustom facemenu-new-faces-at-end t "\
*Where in the menu to insert newly-created faces.
This should be nil to put them at the top of the menu, or t to put them
just before \"Other\" at the end." :type 'boolean :group 'facemenu)

(defcustom facemenu-unlisted-faces '(modeline region secondary-selection highlight scratch-face gui-button-face isearch hyperlink modeline modeline-buffer-id modeline-mousable modeline-mousable-minor-mode pointer primary-selection secondary-selection list-mode-item-selected text-cursor zmacs-region left-margin right-margin "^font-lock-" "^gnus-" "^message-" "^ediff-" "^term-" "^vc-" "^widget-" "^custom-" "^vm-") "\
*List of faces not to include in the Face menu.
Each element may be either a symbol, which is the name of a face, or a string,
which is a regular expression to be matched against face names.  Matching
faces will not be added to the menu.

You can set this list before loading facemenu.el, or add a face to it before
creating that face if you do not want it to be listed.  If you change the
variable so as to eliminate faces that have already been added to the menu,
call `facemenu-update' to recalculate the menu contents.

If this variable is t, no faces will be added to the menu.  This is useful for
temporarily turning off the feature that automatically adds faces to the menu
when they are created." :type '(choice (const :tag "Don't add" t) (const :tag "None" nil) (repeat (choice symbol regexp))) :group 'facemenu)

(defcustom facemenu-relevant-face-attributes '(foreground background font underline highlight dim blinking reverse) "\
*List of face attributes that facemenu fiddles with." :type '(repeat (symbol :tag "Attribute")) :group 'facemenu)

(defcustom facemenu-add-face-function nil "\
Function called at beginning of text to change or `nil'.
This function is passed the FACE to set and END of text to change, and must
return a string which is inserted.  It may set `facemenu-end-add-face'." :type '(choice (const :tag "None" nil) function) :group 'facemenu)

(defcustom facemenu-end-add-face nil "\
String to insert or function called at end of text to change or `nil'.
This function is passed the FACE to set, and must return a string which is
inserted." :type '(choice (const :tag "None" nil) string function) :group 'facemenu)

(defcustom facemenu-remove-face-function nil "\
When non-`nil' function called to remove faces.
This function is passed the START and END of text to change.
May also be `t' meaning to use `facemenu-add-face-function'." :type '(choice (const :tag "None" nil) (const :tag "Use add-face" t) function) :group 'facemenu)

;;;***

;;;### (autoloads (ffap-machine-p-unknown ffap-machine-p-known ffap-machine-p-local ffap-next-regexp ffap-url-fetcher ffap-file-finder ffap-require-prefix ffap-newfile-prompt ffap-dired-wildcards ffap-foo-at-bar-prefix ffap-rfs-regexp ffap-ftp-default-user ffap-url-unwrap-remote ffap-url-unwrap-local ffap-ftp-regexp ffap) "ffap" "xemacs-base/ffap.el")
(defconst custom-define-current-source-file "ffap.el")

(defgroup ffap nil "Find file or URL at point." :link '(url-link :tag "URL" "ftp://ftp.mathcs.emory.edu/pub/mic/emacs/") :group 'matching)

(defcustom ffap-ftp-regexp "\\`/[^/:]+:" "\
*Paths matching this regexp are treated as remote ftp paths by ffap.
If nil, ffap neither recognizes nor generates such paths." :type '(choice (const :tag "Disable" nil) (const :tag "Standard" "\\`/[^/:]+:") regexp) :group 'ffap)

(defcustom ffap-url-unwrap-local t "\
*If non-nil, convert \"file:\" url to local path before prompting." :type 'boolean :group 'ffap)

(defcustom ffap-url-unwrap-remote t "\
*If non-nil, convert \"ftp:\" url to remote path before prompting.
This is ignored if `ffap-ftp-regexp' is nil." :type 'boolean :group 'ffap)

(defcustom ffap-ftp-default-user "anonymous" "\
*User name in ftp paths generated by `ffap-host-to-path'.
Note this name may be omitted if it equals the default
\(either `efs-default-user' or `ange-ftp-default-user')." :type 'string :group 'ffap)

(defcustom ffap-rfs-regexp "\\`/\\(afs\\|net\\)/." "\
*Matching paths are treated as remote.  nil to disable." :type 'regexp :group 'ffap)

(defcustom ffap-foo-at-bar-prefix "mailto" "\
*Presumed URL prefix type of strings like \"<foo.9z@bar>\".
Sensible values are nil, \"news\", or \"mailto\"." :type '(choice (const "mailto") (const "news") (const :tag "Disable" nil)) :group 'ffap)

(defcustom ffap-dired-wildcards nil "\
*A regexp matching filename wildcard characters, or nil.
If `find-file-at-point' gets a filename matching this pattern,
it passes it on to `dired' instead of `find-file'." :type '(choice (const :tag "Disable" nil) (const :tag "Enable" "[*?][^/]*\\'")) :group 'ffap)

(defcustom ffap-newfile-prompt nil "\
*Whether `find-file-at-point' prompts about a nonexistent file." :type 'boolean :group 'ffap)

(defcustom ffap-require-prefix nil "\
*If set, reverses the prefix argument to `find-file-at-point'.
This is nil so neophytes notice ffap.  Experts may prefer to disable
ffap most of the time." :type 'boolean :group 'ffap)

(defcustom ffap-file-finder 'find-file "\
*The command called by `find-file-at-point' to find a file." :type 'function :group 'ffap)

(defcustom ffap-url-fetcher (if (fboundp 'browse-url) 'browse-url 'w3-fetch) "\
*A function of one argument, called by ffap to fetch an URL.
Reasonable choices are `w3-fetch' or a `browse-url-*' function.
For a fancy alternative, get ffap-url.el." :type '(choice (const w3-fetch) (const browse-url) (const browse-url-netscape) (const browse-url-mosaic) function) :group 'ffap)

(defcustom ffap-next-regexp "[/:.~a-zA-Z]/\\|@[a-zA-Z][-a-zA-Z0-9]*\\." "\
*Regular expression governing movements of `ffap-next'." :type 'regexp :group 'ffap)

(defcustom ffap-machine-p-local 'reject "\
*A symbol, one of: `ping', `accept', `reject'.
What `ffap-machine-p' does with hostnames that have no domain." :type '(choice (const ping) (const accept) (const reject)) :group 'ffap)

(defcustom ffap-machine-p-known 'ping "\
*A symbol, one of: ping, accept, reject.
What `ffap-machine-p' does with hostnames that have a known domain
\(see mail-extr.el for the known domains)." :type '(choice (const ping) (const accept) (const reject)) :group 'ffap)

(defcustom ffap-machine-p-unknown 'reject "\
*A symbol, one of: ping, accept, reject.
What `ffap-machine-p' does with hostnames that have an unknown domain
\(see mail-extr.el for the known domains)." :type '(choice (const ping) (const accept) (const reject)) :group 'ffap)

;;;***

;;;### (autoloads (inhibit-field-text-motion field) "field" "xemacs-base/field.el")
(defconst custom-define-current-source-file "field.el")

(defgroup field nil "Text fields." :group 'editing)

(defcustom inhibit-field-text-motion nil "\
*Non-nil means text motion commands do not notice fields." :type 'boolean :group 'field)

;;;***

;;;### (autoloads (imenu-level-separator imenu-space-replacement imenu-scanning-message imenu-max-items imenu-sort-function imenu-always-use-completion-buffer-p imenu-auto-rescan-maxout imenu-auto-rescan imenu-max-item-length imenu-use-markers imenu) "imenu" "xemacs-base/imenu.el")
(defconst custom-define-current-source-file "imenu.el")

(defgroup imenu nil "Mode-specific buffer indexes." :group 'matching :group 'frames)

(defcustom imenu-use-markers t "\
*Non-nil means use markers instead of integers for Imenu buffer positions.

Setting this to nil makes Imenu work a little faster but editing the
buffer will make the generated index positions wrong.

This might not yet be honored by all index-building functions." :type 'boolean :group 'imenu)

(defcustom imenu-max-item-length 60 "\
*If a number, truncate Imenu entries to that length." :type '(choice integer (const :tag "Unlimited")) :group 'imenu)

(defcustom imenu-auto-rescan nil "\
*Non-nil means Imenu should always rescan the buffers." :type 'boolean :group 'imenu)

(defcustom imenu-auto-rescan-maxout 60000 "\
*Imenu auto-rescan is disabled in buffers larger than this size.
This variable is buffer-local." :type 'integer :group 'imenu)

(defcustom imenu-always-use-completion-buffer-p nil "\
*Set this to non-nil for displaying the index in a completion buffer.

`never' means never automatically display a listing of any kind.
A value of nil (the default) means display the index as a mouse menu
if the mouse was used to invoke `imenu'.
Another non-nil value means always display the index in a completion buffer." :type '(choice (const :tag "On Mouse" nil) (const :tag "Never" never) (sexp :tag "Always" :format "%t
" t)) :group 'imenu)

(defcustom imenu-sort-function nil "\
*The function to use for sorting the index mouse-menu.

Affects only the mouse index menu.

Set this to nil if you don't want any sorting (faster).
The items in the menu are then presented in the order they were found
in the buffer.

Set it to `imenu--sort-by-name' if you want alphabetic sorting.

The function should take two arguments and return t if the first
element should come before the second.  The arguments are cons cells;
\(NAME . POSITION).  Look at `imenu--sort-by-name' for an example." :type '(choice (const :tag "No sorting" nil) (const :tag "Sort by name" imenu--sort-by-name) (function :tag "Another function")) :group 'imenu)

(defcustom imenu-max-items 25 "\
*Maximum number of elements in a mouse menu for Imenu." :type 'integer :group 'imenu)

(defcustom imenu-scanning-message "Scanning buffer for index (%3d%%)" "\
*Progress message during the index scanning of the buffer.
If non-nil, user gets a message during the scanning of the buffer.

Relevant only if the mode-specific function that creates the buffer
index use `imenu-progress-message', and not useful if that is fast, in
which case you might as well set this to nil." :type '(choice string (const :tag "None" nil)) :group 'imenu)

(defcustom imenu-space-replacement "." "\
*The replacement string for spaces in index names.
Used when presenting the index in a completion buffer to make the
names work as tokens." :type 'string :group 'imenu)

(defcustom imenu-level-separator ":" "\
*The separator between index names of different levels.
Used for making mouse-menu titles and for flattening nested indexes
with name concatenation." :type 'string :group 'imenu)

;;;***

;;;### (autoloads (passwd-echo passwd-invert-frame-when-keyboard-grabbed passwd) "passwd" "xemacs-base/passwd.el")
(defconst custom-define-current-source-file "passwd.el")

(defgroup passwd nil "Prompting for passwords semi-securely" :group 'processes)

(defcustom passwd-invert-frame-when-keyboard-grabbed (not (featurep 'infodock)) "\
*If non-nil swap the foreground and background colors of all faces.
This is done while the keyboard is grabbed in order to give a visual
clue that a grab is in effect." :type 'boolean :group 'passwd)

(defcustom passwd-echo ?\. "\
*The character which should be echoed when typing a password,
or nil, meaning echo nothing." :type 'sexp :group 'passwd)

;;;***

;;;### (autoloads (shell-output-3-face shell-output-2-face shell-output-face shell-option-face shell-prompt-face shell-mode-hook shell-input-autoexpand explicit-zsh-args explicit-tcsh-args explicit-pdsh-args explicit-ksh-args explicit-csh-args explicit-bash-args explicit-ash-args explicit-shell-file-name shell-dirtrack-process-other-func shell-dirtrack-other-regexp shell-dirtrack-verbose shell-chdrive-regexp shell-cd-regexp shell-pushd-dunique shell-pushd-dextract shell-pushd-tohome shell-pushd-regexp shell-popd-regexp shell-multiple-shells shell-completion-execonly shell-command-separator-regexp shell-command-regexp shell-completion-fignore shell-prompt-pattern shell-dumb-shell-regexp shell-faces shell-directories shell) "shell" "xemacs-base/shell.el")
(defconst custom-define-current-source-file "shell.el")

(defgroup shell nil "Running shell from within Emacs buffers" :group 'processes :group 'unix)

(defgroup shell-directories nil "Directory support in shell mode" :group 'shell)

(defgroup shell-faces nil "Faces in shell buffers" :group 'shell)

(defcustom shell-dumb-shell-regexp "cmd\\(proxy\\)?\\.exe" "\
Regexp to match shells that don't save their command history, and
don't handle the backslash as a quote character.  For shells that
match this regexp, Emacs will write out the command history when the
shell finishes, and won't remove backslashes when it unquotes shell
arguments." :type 'regexp :group 'shell)

(defcustom shell-prompt-pattern "^[^#$%>\n]*[#$%>] *" "\
Regexp to match prompts in the inferior shell.
Defaults to \"^[^#$%>\\n]*[#$%>] *\", which works pretty well.
This variable is used to initialise `comint-prompt-regexp' in the
shell buffer.

This variable is only used if the variable
`comint-use-prompt-regexp-instead-of-fields' is non-nil.

The pattern should probably not match more than one line.  If it does,
Shell mode may become confused trying to distinguish prompt from input
on lines which don't start with a prompt.

This is a fine thing to set in your `.emacs' file." :type 'regexp :group 'shell)

(defcustom shell-completion-fignore nil "\
*List of suffixes to be disregarded during file/command completion.
This variable is used to initialize `comint-completion-fignore' in the shell
buffer.  The default is nil, for compatibility with most shells.
Some people like (\"~\" \"#\" \"%\").

This is a fine thing to set in your `.emacs' file." :type '(repeat (string :tag "Suffix")) :group 'shell)

(defcustom shell-command-regexp "[^;&|\n]+" "\
*Regexp to match a single command within a pipeline.
This is used for directory tracking and does not do a perfect job." :type 'regexp :group 'shell)

(defcustom shell-command-separator-regexp "[;&|\n 	]*" "\
*Regexp to match what separates commands within a pipeline.
This is used for directory tracking and does not do a perfect job." :type 'regexp :group 'shell)

(defcustom shell-completion-execonly t "\
*If non-nil, use executable files only for completion candidates.
This mirrors the optional behavior of tcsh.

Detecting executability of files may slow command completion considerably." :type 'boolean :group 'shell)

(defcustom shell-multiple-shells nil "\
*If non-nil, each time shell mode is invoked, a new shell is made" :type 'boolean :group 'shell)

(defcustom shell-popd-regexp "popd" "\
*Regexp to match subshell commands equivalent to popd." :type 'regexp :group 'shell-directories)

(defcustom shell-pushd-regexp "pushd" "\
*Regexp to match subshell commands equivalent to pushd." :type 'regexp :group 'shell-directories)

(defcustom shell-pushd-tohome nil "\
*If non-nil, make pushd with no arg behave as \"pushd ~\" (like cd).
This mirrors the optional behavior of tcsh." :type 'boolean :group 'shell-directories)

(defcustom shell-pushd-dextract nil "\
*If non-nil, make \"pushd +n\" pop the nth dir to the stack top.
This mirrors the optional behavior of tcsh." :type 'boolean :group 'shell-directories)

(defcustom shell-pushd-dunique nil "\
*If non-nil, make pushd only add unique directories to the stack.
This mirrors the optional behavior of tcsh." :type 'boolean :group 'shell-directories)

(defcustom shell-cd-regexp "cd" "\
*Regexp to match subshell commands equivalent to cd." :type 'regexp :group 'shell-directories)

(defcustom shell-chdrive-regexp (if (memq system-type '(ms-dos windows-nt)) "[]a-zA-Z^_`\\[\\\\]:" nil) "\
*If non-nil, is regexp used to track drive changes." :type '(choice regexp (const nil)) :group 'shell-directories)

(defcustom shell-dirtrack-verbose t "\
*If non-nil, show the directory stack following directory change.
This is effective only if directory tracking is enabled." :type 'boolean :group 'shell-directories)

(defcustom shell-dirtrack-other-regexp nil "\
*Regexp to match commands for which we call `shell-dirtrack-process-other-func'." :type '(choice regexp (const nil)) :group 'shell-directories)

(defcustom shell-dirtrack-process-other-func nil "\
*Function to allow external processing of directory changing commands
which match `shell-dirtrack-other-regexp'.  This allows users to process
arbitrary directory changing commands.  This function takes two arguments:
  CMD  - the first word (cmd part) of the current shell command line.
  ARG1 - the rest of the current shell command line.
See `shell-process-popd', etc., for an example of things for which this
function might be used.  The motivation for this was to provide a
pushd-like command which expands ARG1 from an abbrev-table." :type 'function :group 'shell-directories)

(defcustom explicit-shell-file-name nil "\
*If non-nil, is file name to use for explicitly requested inferior shell." :type '(choice (const :tag "None" nil) file) :group 'shell)

(defcustom explicit-ash-args '("-i") "\
*List of arguments to pass to \"ash\" on startup in `shell-mode'." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom explicit-bash-args (let* ((prog (or (and (boundp 'explicit-shell-file-name) explicit-shell-file-name) (getenv "ESHELL") shell-file-name)) (name (file-name-nondirectory prog))) (if (and (not purify-flag) (equal name "bash") (file-executable-p prog) (string-match "bad option" (shell-command-to-string (concat prog " --noediting")))) '("-i") '("--noediting" "-i"))) "\
*Args passed to inferior shell by M-x shell, if the shell is bash.
Value is a list of strings, which may be nil." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom explicit-csh-args (if (eq system-type 'hpux) '("-i" "-T") '("-i")) "\
*Args passed to inferior shell by M-x shell, if the shell is csh.
Value is a list of strings, which may be nil." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom explicit-ksh-args '("-i") "\
*List of arguments to pass to \"ksh\" on startup in `shell-mode'." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom explicit-pdsh-args '("-i") "\
*List of arguments to pass to \"pdksh\" on startup in `shell-mode'." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom explicit-tcsh-args '("-i") "\
*List of arguments to pass to \"tcsh\" on startup in `shell-mode'." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom explicit-zsh-args '("-i") "\
*List of arguments to pass to \"zsh\" on startup in `shell-mode'." :type '(repeat (string :tag "Argument")) :group 'shell)

(defcustom shell-input-autoexpand 'history "\
*If non-nil, expand input command history references on completion.
This mirrors the optional behavior of tcsh (its autoexpand and histlit).

If the value is `input', then the expansion is seen on input.
If the value is `history', then the expansion is only when inserting
into the buffer's input ring.  See also `comint-magic-space' and
`comint-dynamic-complete'.

This variable supplies a default for `comint-input-autoexpand',
for Shell mode only." :type '(choice (const :tag "off" nil) (const input) (const history) (const :tag "on" t)) :group 'shell)

(defcustom shell-mode-hook nil "\
*Hook for customising Shell mode." :type 'hook :group 'shell)

(defcustom shell-prompt-face 'shell-prompt-face "\
Face for shell prompts." :type 'face :group 'shell-faces)

(defcustom shell-option-face 'shell-option-face "\
Face for command line options." :type 'face :group 'shell-faces)

(defcustom shell-output-face 'shell-output-face "\
Face for generic shell output." :type 'face :group 'shell-faces)

(defcustom shell-output-2-face 'shell-output-2-face "\
Face for grep-like output." :type 'face :group 'shell-faces)

(defcustom shell-output-3-face 'shell-output-3-face "\
Face for [N] output where N is a number." :type 'face :group 'shell-faces)

;;;***

;;;### (autoloads (sort-numeric-base sort-fold-case sort) "sort" "xemacs-base/sort.el")
(defconst custom-define-current-source-file "sort.el")

(defgroup sort nil "Commands to sort text in an Emacs buffer." :group 'data)

(defcustom sort-fold-case nil "\
*Non-nil if the buffer sort functions should ignore case." :group 'sort :type 'boolean)

(defcustom sort-numeric-base 10 "\
*Fallback base for `sort-numeric-fields', `sort-regexp-fields-numerically'." :group 'sort :type 'integer)

;;;***

;;;### (autoloads (time-stamp-format time-stamp-warn-inactive time-stamp-active time-stamp) "time-stamp" "xemacs-base/time-stamp.el")
(defconst custom-define-current-source-file "time-stamp.el")

(defgroup time-stamp nil "Maintain last change time stamps in files edited by Emacs." :group 'data :group 'extensions)

(defcustom time-stamp-active t "\
*Non-nil to enable time-stamping of buffers by \\[time-stamp].
Can be toggled by \\[time-stamp-toggle-active].
See also the variable time-stamp-warn-inactive." :type 'boolean :group 'time-stamp)

(defcustom time-stamp-warn-inactive t "\
*Non-nil to have \\[time-stamp] warn if a buffer did not get time-stamped.
A warning is printed if time-stamp-active is nil and the buffer contains
a time stamp template that would otherwise have been updated." :type 'boolean :group 'time-stamp)

(defcustom time-stamp-format "%02y/%02m/%02d %02H:%02M:%02S %u" "\
*Template for the string inserted by \\[time-stamp].
Value may be a string or a list.  (Lists are supported only for
backward compatibility.)  A string is used verbatim except
for character sequences beginning with %:

%a  weekday name: `Monday'.		%A gives uppercase: `MONDAY'
%b  month name: `January'.		%B gives uppercase: `JANUARY'
%d  day of month
%H  24-hour clock hour
%I  12-hour clock hour
%m  month number
%M  minute
%p  `am' or `pm'.			%P gives uppercase: `AM' or `PM'
%S  seconds
%w  day number of week, Sunday is 0
%y  year: `1995'
%z  time zone name: `est'.		%Z gives uppercase: `EST'

Non-date items:
%%  a literal percent character: `%'
%f  file name without directory		%F gives absolute pathname
%s  system name
%u  user's login name
%h  mail host name

Decimal digits between the % and the type character specify the
field width.  Strings are truncated on the right; numbers on the left.
A leading zero causes numbers to be zero-filled.

For example, to get the format used by the `date' command,
use \"%3a %3b %2d %02H:%02M:%02S %Z %y\"" :type 'string :group 'time-stamp)

;;;***

(provide 'xemacs-base-custom-defines)
